{%- set sort_field = sort_field -%}
{%- set filters = filters or [] -%}

{# Prepare filters #}
{%- set ns = namespace(query_filters=[], method=frappe.get_list) -%}
{% set filt = ["Event", "published", "=", "1"] -%}
{% set ns.query_filters = ns.query_filters + [filt] -%}
{% set ns.method = frappe.get_all -%}
{% set date = frappe.utils.get_datetime() %}

{%- for filt in filters -%}
	{%- if filt.fieldname and filt.value -%}
	{%- set filt = ["Event", filt.fieldname, "=", filt.value] -%}
		{%- set ns.query_filters = ns.query_filters + [filt] -%}
	{%- endif -%}
{%- endfor -%}

{% if not display_past_event %}
	{% set ns.query_filters = ns.query_filters + [["Event", "starts_on", ">=", frappe.utils.today()]] %}
{% endif %}

{%- set event_list = ns.method(
	"Event",
	filters=ns.query_filters,
	order_by=sort_field,
	limit=limit,
	pluck="name",
) -%}

{%- macro event_card(event, is_full_width=False, align="Left") -%}
	{# {%- set align_events_class = resolve_class({
		'align-events-end': align == 'Right',
		'align-events-center': align == 'Center',
		'align-events-start': align == 'Left',
	}) -%} #}
	{# {%- set col_size = 3 if is_full_width else 4 -%} #}
	{%- set title = event.subject -%}
	{%- set title = title[:50] + "..." if title|len > 50 else title -%}
	{%- set image = event.image -%}
	{%- set description = event.short_description-%}

	<a href="/{{ event.route or '#' }}" class="card event-card align-items-stretch" style="overflow: hidden;" itemscope itemtype="http://schema.org/Event">
		{% if image %}
			<div class="card-img-container">
				<img class="card-img" src="{{ image }}" alt="">
			</div>
		{% else %}
			<div class="card-img-top no-image" aria-hidden="true">
				{{ frappe.utils.get_abbr(title) }}
			</div>
		{% endif %}

		{{ event_card_body(title, description, event, align) }}
	</a>
{%- endmacro -%}


{%- macro event_card_date(date, extras="") -%}
	{% if date %}
		{% set date = frappe.utils.get_datetime(date) %}
		<time datetime="{{ date.isoformat() }}" {{ extras | safe}}>
			{% set weekday = _(date.strftime("%A"))[:3] %}
			{% set rest = date.strftime("%d/%m, %R") %}
			{{ weekday }} {{ rest }}
		</time>
	{% endif %}
{%- endmacro -%}

{%- macro event_card_body(title, description, event, align) -%}
	{# {%- set align_class = resolve_class({
		'text-right': align == 'Right',
		'text-center': align == 'Center',
		'text-left': align == 'Left',
	}) -%} #}
	{% if event.published_address %}
		{% set address = frappe.get_doc("Address", event.published_address) %}
	{% endif %}

	<article class="card-body">
		{% if title %}
		<header class="product-title">
			<div role="heading" aria-level="1" class="font-size-lg" itemprop="name">
				{{ title }}
			</div>
		</header>
		{% endif %}

		<div class="small d-flex align-center" style="color: var(--primary); gap: 0.5ch; margin: var(--margin-sm) 0;">
			{% if event.repeat_this_event %}
			<svg aria-label="{{ _('Repeated event') |e }}" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-repeat"><polyline points="17 1 21 5 17 9"></polyline><path d="M3 11V9a4 4 0 0 1 4-4h14"></path><polyline points="7 23 3 19 7 15"></polyline><path d="M21 13v2a4 4 0 0 1-4 4H3"></path></svg>
			{% endif %}

			<svg aria-label="{{ _('Starts On') |e }}" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-calendar"><rect x="3" y="4" width="18" height="18" rx="2" ry="2"></rect><line x1="16" y1="2" x2="16" y2="6"></line><line x1="8" y1="2" x2="8" y2="6"></line><line x1="3" y1="10" x2="21" y2="10"></line></svg>

			{{ event_card_date(event.starts_on, 'class="font-weight-bold" itemprop="startDate"') }}
		</div>

		{% if address %}
		<div class="small" itemprop="location">
			<svg aria-label="{{ _('Address') |e }}" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-map-pin"><path d="M21 10c0 7-9 13-9 13s-9-6-9-13a9 9 0 0 1 18 0z"></path><circle cx="12" cy="10" r="3"></circle></svg>
			{{ address | get_condensed_address }}
		</div>
		{% endif %}

		<div class="small">
			{% if event.registration_amount %}
				<div itemprop="offers" itemscope itemtype="http://schema.org/Offer">
					<svg aria-label="{{ _('Price') |e }}" class="icon icon-sm"><use href="#icon-income"></use></svg>
					<span itemprop="price">
						{{ frappe.format(event.registration_amount, df=event.meta.get("fields", {"fieldname": "registration_amount"})[0]) }}
					</span>
				</div>
			{% else %}
				{{ _("Free") }}
			{% endif %}
		</div>
	</article>
{%- endmacro -%}


{% set primary_action = "/events" %}
{% set primary_action_label = _("View List") %}

<div class="section-with-cards item-card-group-section">
	<div class="item-group-header d-flex justify-content-between mb-4">
		<div class="title-section">
			{%- if title -%}
			<h2 class="section-title m-0">
				{{ title }}
			</h2>
			{%- endif -%}
			{%- if subtitle -%}
			<p class="section-description">
				{{ subtitle }}
			</p>
			{%- endif -%}
		</div>
		<div class="primary-action-section" style="margin-top: auto;">
			{%- if primary_action -%}
			<a href="{{ primary_action }}" class="btn btn-primary pull-right">
				{{ primary_action_label }}
			</a>
			{%- endif -%}
		</div>
	</div>

	<div style="display: flex; flex-wrap: wrap; gap: 1em; display: grid; grid-template-columns: repeat(auto-fill, minmax(250px, 1fr)); grid-template-rows: 1fr; align-items: stretch; justify-items: stretch;">
		{%- for event in event_list: -%}
			{%- set event = frappe.get_doc('Event', event) -%}
			{{ event_card(event, is_full_width=True, align='Center') }}
		{%- endfor -%}
	</div>

	{%- if primary_action and (event_list | length) >= 24 -%}
	<div class="text-center m-4">
		<a href="{{ primary_action }}" class="btn btn-primary btn-lg">
			{{ primary_action_label }}
		</a>
	</div>
	{%- endif -%}
</div>
